const mongoose = require('mongoose');
const { database } = require('../src/server/config/keys');
const bcrypt = require("bcryptjs");

const admins = require('./data/Admin.json');
const userModel = require('../src/models/user');


mongoose.connect(database.URI, { useNewUrlParser: true })
	.then(db => console.log('DB Connected'))
	.catch(err => console.error(err));

const insertAdmins = async () => {
	const insertAdmin = async admin => {
		const password = await bcrypt.hash(admin.password, 12);

		const userData = new userModel({
			user: admin.user,
			password: password,
			name: admin.name,
			surname: admin.surname,
			role: admin.role,
		});

		const session = await userModel.startSession();
		session.startTransaction();

		try {
			const existingUser = await userModel.findOne({ user: admin.user });

			// Comprobamos que no existe el usuario
			if (existingUser) console.log('El administrador ', admin.user, ' ya existe')
			else {
				const options = { session };

				await userData.save(options);
			}

			// OK: Commit transaction
			await session.commitTransaction();
			session.endSession();
			return true;
		}

		catch (error) {
			// KO: Abort transaction
			await session.abortTransaction();
			session.endSession();
			console.log(error)
		}
	}

	let count = 0;
	for (const admin of admins) {

		count++;
		console.log(count);

		let flag = false;

		while (!flag)
			flag = await insertAdmin(admin);
	}

	console.log('Finalizado');
};

insertAdmins();