const mongoose = require('mongoose');
const { database } = require('../src/server/config/keys');
const bills = require('./data/Facturas.json');
const billModel = require('../src/models/bill');
const projectModel = require('../src/models/project');

mongoose.connect(database.URI, { useNewUrlParser: true })
	.then(db => console.log('DB Connected'))
	.catch(err => console.error(err));

const createBills = async () => {
	const createBill = async bill => {
		const billData = new billModel({
			fecha: bill.fecha,
			epigrafe: bill.epigrafe,
			concepto: bill.concepto,
			emisor: bill.emisor,
			cuantia_dolares: bill.cuantia_dolares,
			cuantia_euros: bill.cuantia_euros
		});

		const nproj = bill.n_proyecto;

		const session = await billModel.startSession();
		session.startTransaction();

		try {
			const options = { session };

			const newBill = await billData.save(options);

			const project = await projectModel.findOne({ Identificador: nproj });

			if (project.Facturas) {
				project.Facturas.push(newBill._id);
			}

			else {
				project.Facturas = [newBill._id]
			}

			await project.save(options);

			// OK: Commit transaction
			await session.commitTransaction();
			session.endSession();
			return true;
		}

		catch (error) {
			// KO: Abort transaction
			await session.abortTransaction();
			session.endSession();
			console.log(error)
		}
	}

	let count = 0;
	for (const bill of bills) {
				
		count++;
		console.log(count);

		let flag = false;

		while(!flag)
			flag = await createBill(bill);
	}
	
	console.log('Finalizado');
};

createBills();