const mongoose = require('mongoose');
const { database } = require('../src/server/config/keys');
const entities = require('./data/Entidades.json');
const projectModel = require('../src/models/project');

mongoose.connect(database.URI, { useNewUrlParser: true })
	.then(db => console.log('DB Connected'))
	.catch(err => console.error(err));

const createEntities = async () => {
	const createEntity = async entity => {
		const placeData = {
			Descripcion: entity.desc_entidad
		};

		const nproj = entity.n_proyecto;

		const session = await projectModel.startSession();
		session.startTransaction();

		try {
			const options = { session };

			const project = await projectModel.findOne({ Identificador: nproj });

			if (project) {
				if (project.Entidades) {
					project.Entidades.push(placeData);
				}

				else {
					project.Entidades = [placeData]
				}

				await project.save(options);
			}
			// OK: Commit transaction
			await session.commitTransaction();
			session.endSession();
			return true;
		}

		catch (error) {
			// KO: Abort transaction
			await session.abortTransaction();
			session.endSession();
			console.log(error)
		}
	}

	flag = 0
	for (const entity of entities) {
		flag++
		console.log('Insertando', flag);
		await createEntity(entity);
	}

	console.log('Finalizado');
};

createEntities();