const mongoose = require('mongoose');
const { database } = require('../src/server/config/keys');
const places = require('./data/Lugares.json');
const projectModel = require('../src/models/project');

mongoose.connect(database.URI, { useNewUrlParser: true })
	.then(db => console.log('DB Connected'))
	.catch(err => console.error(err));

const createPlaces = async () => {
	const createPlace = async place => {
		const placeData = {
			Descripcion: place.desc_lugar
		};

		const nproj = place.n_proyecto;

		const session = await projectModel.startSession();
		session.startTransaction();

		try {
			const options = { session };

			const project = await projectModel.findOne({ Identificador: nproj });

			if (project) {
				if (project.Lugares) {
					project.Lugares.push(placeData);
				}

				else {
					project.Lugares = [placeData]
				}

				await project.save(options);
			}
			// OK: Commit transaction
			await session.commitTransaction();
			session.endSession();
			return true;
		}

		catch (error) {
			// KO: Abort transaction
			await session.abortTransaction();
			session.endSession();
			console.log(error)
		}
	}

	flag = 0
	for (const place of places) {
		flag++
		console.log('Insertando', flag);
		await createPlace(place);

	}

	console.log('Finalizado');
};

createPlaces();