const mongoose = require('mongoose');
const { database } = require('../src/server/config/keys');
const sectors = require('./data/Sectores.json');

const relacionSec = require('./data/RelacionSectores.json');
const sectorModel = require('../src/models/sector');
const projectModel = require('../src/models/project');

mongoose.connect(database.URI, { useNewUrlParser: true })
	.then(db => console.log('DB Connected'))
	.catch(err => console.error(err));

const createSectors = async () => {
	const createSector = async sector => {
		const sectorData = new sectorModel({
			codCrs: sector.codCrs,
			descripcion_es: sector.descripcion_es,
			descripcion_en: sector.descripcion_en
		});

		await sectorData.save();
		return true;
	};

	const insertSector = async project => {
		if (project.codCrs.length > 0) {
			for (const codigo of project.codCrs) {
				const sector = await sectorModel.findOne({ codCrs: codigo });
				if (project.Sectores)
					project.Sectores.push(sector._id);
				else
					project.Sectores = [sector._id]
			}
			await project.save();
		}

		return true;
	};

	//Insertamos los sectores en una colección
	for (const sector of sectors) {
		let flag = false;

		while (!flag)
			flag = await createSector(sector);
	};

	//Enlazamos cada proyecto con su sector
	const projects = await projectModel.find();

	projects.forEach(async (project) => {
		let flag = false;

		while (!flag) {
			flag = await insertSector(project);
		}

		//Eliminamos el campo sobrante que hemos utilizado para enlazar
		project.codCrs = undefined;
		await project.save();
	});

	console.log('Finalizado');
};

createSectors();