const mongoose = require('mongoose');
const { database } = require('../src/server/config/keys');
const types = require('./data/Tipos.json');

const typeModel = require('../src/models/type');
const projectModel = require('../src/models/project');

mongoose.connect(database.URI, { useNewUrlParser: true })
	.then(db => console.log('DB Connected'))
	.catch(err => console.error(err));

const createTypes = async () => {
	const createType = async type => {
		const typeData = new typeModel({
			id: type.id,
			tipo_es: type.tipo_es
		});

		await typeData.save();
		return true;
	};

	const insertType = async project => {
		const type = await typeModel.findOne({ id: project.TipoNum })
		project.Tipo = type._id;
		const res = await project.save(err => {
			if (err) return false
		});

		return true;
	};

	//Insertamos los tipos en una colección
	for (const type of types) {
		let flag = false;

		while (!flag)
			flag = await createType(type);
	};

	//Enlazamos cada proyecto con su tipo
	const projects = await projectModel.find();

	projects.forEach(async (project) => {
		let flag = false;

		while (!flag) {
			flag = await insertType(project);
		}

		//Eliminamos el campo sobrante que hemos utilizado para enlazar
		project.TipoNum = undefined;
		await project.save();
	});

	console.log('Finalizado');
};

createTypes();