// LIBRERIAS Y FRAMEWORKS
import React, { useContext } from 'react';
import { Link } from 'react-router-dom';

//COMPONENTES
import { Container, Row, Col, Svg, Wrapper } from '../../global/';

// CONTEXTOS, REDUCERS ...
import GlobalContext from '../../contexts/global/Context';

//ESTILOS
import styles from './styles/Footer.scss'

const Footer = () => {
	const { resolution } = useContext(GlobalContext);

	const borderRight = resolution !== 'xs' ? styles.borderRight : null;
	const borderTop = resolution === 'xs' ? styles.borderTop : null;
	const spaceXs = resolution === 'xs' ? styles.spaceXs : null;

	return (
		<Container>
			<Row styles={["padd-v-05"]}>
				<Col size={resolution} xs={12} sm={6} md={8} lg={8} class={[borderRight, spaceXs]} styles={["padd-h-1", "flex-c-c"]}>
					<h2 styleName='title'>Eficiencia en la Cooperación Internacional para el Desarrollo</h2>
				</Col>
				<Col size={resolution} xs={12} sm={6} md={4} lg={4} class={[borderTop, spaceXs]} styles={["padd-h-1", "flex-s-c", "dir-col"]}>
					<h3 styleName='titleLinks'>ENLACES</h3>
					<ul>
						<li>
							<a target='_blank' href="http://localhost:3000/privacity">
								<h4>Política de privacidad</h4>
							</a>
						</li>
						<li>
							<a target='_blank' href="http://www.uva.es/export/sites/uva/">
								<h4>Página oficial de la UVa</h4>
							</a>
						</li>
						<li>
							<a target='_blank' href="http://www.eco.uva.es/">
								<h4>Página oficial de la FCEE</h4>
							</a>
						</li>
						<li>
							<a target='_blank' href="https://www.inf.uva.es/">
								<h4>Página oficial de la EIIV</h4>
							</a>
						</li>
					</ul>
				</Col>
			</Row>
		</Container>
	)
}

export default Footer;