import React from 'react';

import './styles/Col.scss';

const Col = props => {

	const col = getColClass(props);
	const style = col ? stylesToString(col, props.styles) : null;
	const classes = classToString(props.class);

	return (
		<>
			{style
				? <div className={classes} styleName={style}>{props.children}</div>
				: null}
		</>
	);
};

const getColClass = props => {
	if (props.fixed) return props.fixed;

	const col = props[props.size];

	return col !== 0 ? col : null;
};

const stylesToString = (col, stylesArray) => {
	let style = `col-${col}`;

	if (stylesArray)
		stylesArray.forEach(i => {
			style += ` ${i}`;
		});

	return style;
};

const classToString = styles => {
	let classes = '';
	if (styles)
		styles.forEach(i => {
			classes += ` ${i}`
		});

	return classes;
};

export default Col;
