import React from 'react';

import './styles/Container.scss';

const Container = props => {
	const style = stylesToString(props.size, props.styles);
	const classes = classToString(props.class);


	return (
		<div className={classes} styleName={style}>
			{props.children}
		</div>
	)
};

const stylesToString = (size, stylesArray) => {
	let style = 'container';
	if (size) style = `container-${size}`

	if (stylesArray)
		stylesArray.forEach(i => {
			style += ` ${i}`
		});

	return style;
};

const classToString = styles => {
	let classes = '';
	if (styles)
		styles.forEach(i => {
			classes += ` ${i}`
		});

	return classes;
};

export default Container;