import React from 'react';

import '../styles/CheckBox.scss';

/**
	 * 	@param  {Object} props Objeto compuesto por los siguientes parámetros
	 * 		@param {String} props.text Texto que aparecerá detras del checkbox
	 * 		@param {String} props.name Nombre que se le asigna internamente al checkbox
	 * 		@param {String} props.onChange Nombre que se le asigna internamente al checkbox
	 * 		@param {String} props.disableEnter Deshabilitar la tecla del ENTER para enviar formulario
	 *
*/

const CheckBox = props => {
	const text = props.text ? props.text : 'No hay texto';
	const name = props.name ? props.name : 'defaultName';
	const onChange = props.onChange ? props.onChange : () => null;
	const disableEnter = props.disableEnter;

	return (
		<div styleName='checkbox'>
			<label>
				<input type='checkbox'
					name={name}
					onKeyPress={disableEnter}
					onChange={onChange}
				/>
				<span styleName="check"></span>
				<p>{text}</p>
			</label>
		</div>
	)
};

export default CheckBox;