import React from 'react';
import { Link } from 'react-router-dom';

/**
 * 
 * @param {Object} props Objeto compuesto por los siguientes parámetros
 * 		@param {String} props.label Texto que contiene el enlace
 *  		@param {String} [props.link] Dirección de redirección
 *			@param {Function} [props.onClick] Funcion que se ejecutará al pulsar el enlace
 * 		@param {String} [props.textBef] Texto situado antes del enlace
 *			@param {String} [props.textAft] Texto situado después del enlace
 */

const LinkTo = props => {

	return (
		<div>
			<p>
				{props.textBef}
				{props.onClick
					? <a onClick={props.onClick}>
						<b>{props.label}</b>
					</a>
					: null
				}
				{props.link
					? <Link to={props.link}>
						<b>{props.label}</b>
					</Link>
					: null
				}
				{props.textAft}
			</p>
		</div>
	)
};

export default LinkTo;