import Query from "./Query";

export default class GraphAPI {

  static getGraph(xAxis, yAxis) {
    const graphQuery = `
      query{
          getGraph(input: {
          	xAxis: "${xAxis}",
         	  yAxis: "${yAxis}"
          }) 
          {
             data{
              anio
              varCruzada
            }
            errors
          }
      } 
    `;

    return Query.executeQuery("getGraph", graphQuery);
  }

  static getTypes() {
    const graphQuery = `
      query{
          getTypes
          {
            types
            errors
          }
      } 
    `;
    return Query.executeQuery("getTypes", graphQuery, true);
  }

  static insertProject(values) {
    const graphQuery = `
      mutation{
        insertProject(input:{
          acronym: "${values.acronym}"
          beneficiary: "${values.beneficiary}"
          country: "${values.country}"
          effectiveness: "${values.effectiveness}"
          efficiency: "${values.efficiency}"
          finalDelay: "${values.finalDelay}"
          identifier: "${values.identifier}"
          impact: "${values.impact}"
          initialDelay: "${values.initialDelay}"
          nAreBenef: "${values.nAreBenef}"
          nFamBenef: "${values.nFamBenef}"
          nIndBenef: "${values.nIndBenef}"
          nPerSC: "${values.nPerSC}"
          nPerSE: "${values.nPerSE}"
          nPerSS: "${values.nPerSS}"
          participation: "${values.participation}"
          realTime: "${values.realTime}"
          relevance: "${values.relevance}"
          title: "${values.title}"
          totalFinanced: "${values.totalFinanced}"
          totalQuantity: "${values.totalQuantity}"
          typeSel: "${values.typeSel}"
          valorTotalEjec: "${values.valorTotalEjec}"
          valorTotalPres: "${values.valorTotalPres}"
          viability: "${values.viability}"
          visibility: "${values.visibility}"
          year: "${values.year}"
        })
}
    `;
    console.log(graphQuery)
    return Query.executeQuery("insertProject", graphQuery, true);
  }

}



/*
          acronym: "jk",
          beneficiary: "jklh",
          country: "hjkñl",
          effectiveness: "BAJA",
          efficiency: "MEDIA",
          finalDelay: "ljh",
          identifier: "hjkñ",
          impact: "MEDIA",
          initialDelay: "jlkh",
          nAreBenef: "hjkl",
          nFamBenef: "hjk",
          nIndBenef: "hjk",
          nPerSC: "gfds",
          nPerSE: "gfdsg",
          nPerSS: "hljkgfds",
          participation: "MEDIA-ALTA",
          realTime: "kfdsa",
          relevance: "MEDIA-ALTA",
          title: "hjkl",
          totalFinanced: "hkjl",
          totalQuantity: "jklh",
          typeSel: "SUBV. DE ESTADO",
          valorTotalEjec: "hjkl",
          valorTotalPres: "hjkl",
          viability: "MEDIA",
          visibility: "MEDIA-ALTA",
          year: "hjklh"
*/
