export default class GraphQl {
	static executeQuery(name, query, isAuth) {
		const headers = isAuth
			? {
				"Content-Type": "application/json",
				Authorization: "Bearer " + localStorage.token,
			}
			: {
				"Content-Type": "application/json"
			}

		return fetch("http://localhost:3000/graphql", {
			method: "POST",
			headers,
			body: JSON.stringify({ query })
		})
			.then(res => {
				if (res.status !== 200) {
					throw new Error("Error interno del servidor.");
				}
				return res.json()
			})
			.then(resData => {
				return resData.data[name];
			})
			.catch(() => {
				return null;
			});
	}
}