import styles from '../../styles/forms.scss';

export default class Forms {
	static Login() {
		return [
			{
				element: 'input',
				values: {
					type: 'name',
					placeHolder: 'Usuario',
					name: 'name',
					style: styles.input
				},
				size: 12
			},
			{
				element: 'input',
				values: {
					type: 'pass',
					placeHolder: 'Contraseña',
					name: 'pass',
					style: styles.input,
					required: true
				},
				size: 12,
				enableEnter: true
			},
			{
				element: 'submit',
				values: {
					styles: 'padd-h-025',
					text: 'ENTRAR',
					style: styles.submit
				}
			}
		]
	}

	static InsertProject(types, handlerSelType, handlerInpType) {
		return [
			{
				element: 'select',
				values: {
					placeHolder: 'Tipo',
					name: 'typeSel',
					values: types,
					size: 'md',
					onChange: handlerSelType
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nuevo tipo',
					name: 'type',
					style: styles.input,
					onChange: handlerInpType
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Identificador',
					name: 'identifier',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Pais',
					name: 'country',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Año',
					name: 'year',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Beneficiario',
					name: 'beneficiary',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Acrónimo',
					name: 'acronym',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Financiado Total',
					name: 'totalFinanced',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Titulo',
					name: 'title',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Cuantía Total',
					name: 'totalQuantity',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Retraso Inicial',
					name: 'initialDelay',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Retraso Final',
					name: 'finalDelay',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Duración Real',
					name: 'realTime',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Eficacia',
					name: 'effectiveness',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Eficiencia',
					name: 'efficiency',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Impacto',
					name: 'impact',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Pertinencia',
					name: 'relevance',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Participacion',
					name: 'participation',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Viabilidad',
					name: 'viability',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'select',
				values: {
					placeHolder: 'Visibilidad',
					name: 'visibility',
					values: ['NO EXISTE', 'NO VALORABLE', 'BAJA', 'MEDIA', 'MEDIA-ALTA', 'ALTA', 'MUY ALTA'],
					size: 'md',
					onChange: null
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nº individuos beneficiados',
					name: 'nIndBenef',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nº familias beneficiados',
					name: 'nFamBenef',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nº areas beneficiados',
					name: 'nAreBenef',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Valor total presupuestado',
					name: 'valorTotalPres',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Valor total ejecutado',
					name: 'valorTotalEjec',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nº personas a sueldo en sede',
					name: 'nPerSS',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nº personas a sueldo expatriados',
					name: 'nPerSE',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'input',
				values: {
					type: 'text',
					placeHolder: 'Nº personas a sueldo contratadas',
					name: 'nPerSC',
					style: styles.input
				},
				styles: ['marg-v-05', 'padd-h-05'],
				size: 6
			},
			{
				element: 'submit',
				values: {
					styles: 'padd-h-025',
					text: 'REGISTRAR',
					style: styles.submit
				}
			}

		]
	}
}