const mongoose = require('mongoose');
const Schema = mongoose.Schema;


const ProjectSchema = new Schema({
    Identificador: { type: String, required: true },
    Pais: { type: String, required: true },
    Tipo: { type: Schema.Types.ObjectId, ref: 'Type', required: true },
    Año: { type: Number, required: true },
    Beneficiario: { type: String, required: true },
    Acronimo: { type: String },
    FinanciadoTotal: { type: Number },
    Titulo: { type: String },
    CuantiaTotal: { type: Number },
    RetrasoInicial: { type: Number },
    RetrasoFinal: { type: Number },
    DuracionReal: { type: Number },
    Eficacia: { type: String },
    Eficiencia: { type: String },
    Impacto: { type: String },
    Pertinencia: { type: String },
    Participacion: { type: String },
    Viabilidad: { type: String },
    Visibilidad: { type: String },
    NIndBenef: { type: Number },
    NFamBenef: { type: Number },
    NAreBenef: { type: Number },
    ValorTotalPres: { type: Number },
    ValorTotalEjec: { type: Number },
    NPerSS: { type: Number },
    NPerSE: { type: Number },
    NPerSC: { type: Number },
    Cofinanciadores: [{
        Cofinanciador: { type: String, required: true },
        Cuantia_pres: { type: Number, required: true },
        Cuantia_ejec: { type: Number, required: true }
    }],
    Facturas: [{ type: Schema.Types.ObjectId, ref: 'Bill' }],
    Actividades: [{ type: Schema.Types.ObjectId, ref: 'Activity' }],
    Sectores: [{ type: Schema.Types.ObjectId, ref: 'Sector' }],
    codCrs: [{ type: Number }],
    Entidades: [{
        Descripcion: { type: String, required: true }
    }],
    Lugares: [{
        Descripcion: { type: String, required: true }
    }]
});


module.exports = mongoose.model('Project', ProjectSchema);
