const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const UserSchema = new Schema({
    user: { type: String, required: true },
    password: { type: String, required: true },
    name: { type: String, required: true },
    surname: { type: String, required: true },
    role: { type: String, required: true },
    active: { type: Boolean, required: true, default: true },
    lastLogin: { type: Date, required: false },
    lastIP: { type: String, required: false },
    projects: [{
        reference: { type: Schema.Types.ObjectId, ref: 'Project' },
        lastModified: { type: Date, required: true }
    }]
});


module.exports = mongoose.model('User', UserSchema);