const Project = require("../../../models/project");
const Type = require("../../../models/type");

const getGraph = async ({ input }) => {
	const projects = await Project.find();
	var data = [];
	var errors = []
	var flag = true;

	if (!input.xAxis) errors.push("Seleccione una opción como la variable principal")
	if (!input.yAxis) errors.push("Seleccione una opción como la variable a cruzar")
	if (input.xAxis !== 'Año' && input.xAxis !== 'Eficiencia') errors.push("La opcion seleccionada no existe")

	//Variable Principal Año
	if (input.xAxis === 'Año') {
		var años = []
		projects.forEach(i => {
			if (!años.includes(i.Año))
				años.push(i.Año)
		})

		años.sort();

		años.forEach(i => {
			var contador = 0;
			var sumador = 0;
			var contenedor = [];
			if (flag) {
				switch (input.yAxis) {
					case 'Eficiencia':
						projects.forEach(j => {
							if (j.Año === i && j.Eficiencia && j.Eficiencia !== 'NO EXISTE') {
								if (j.Eficiencia === 'BAJA')
									sumador += 1
								if (j.Eficiencia === 'MEDIA')
									sumador += 2
								if (j.Eficiencia === 'MEDIA-ALTA')
									sumador += 3
								if (j.Eficiencia === 'ALTA')
									sumador += 4
								if (j.Eficiencia === 'MUY ALTA')
									sumador += 5
								contador++;
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					case 'Actividades':
						projects.forEach(j => {
							if (j.Año === i && j.Actividades.length !== 0) {
								contador++;
								sumador += j.Actividades.length
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					case 'Beneficiarios':
						projects.forEach(j => {
							if (j.Año === i && j.NIndBenef) {
								contador++;
								sumador += j.NIndBenef
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					case 'Entidades':
						projects.forEach(j => {
							if (j.Año === i && j.Entidades.length !== 0) {
								contador++;
								sumador += j.Entidades.length
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					case 'Cofinanciadores':
						projects.forEach(j => {
							if (j.Año === i && j.Cofinanciadores.length !== 0) {
								contador++;
								sumador += j.Cofinanciadores.length
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					case 'Lugares':
						projects.forEach(j => {
							if (j.Año === i && j.Lugares.length !== 0) {
								contador++;
								sumador += j.Lugares.length
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					case 'Paises':
						projects.forEach(j => {
							if (j.Año === i && j.Pais && !contenedor.includes(j.Pais)) {
								contenedor.push(j.Pais)
								contador++
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: contenedor.length })
						break
					case 'Sectores':
						projects.forEach(j => {
							if (j.Año === i && j.Sectores.length !== 0) {
								contador++;
								sumador += j.Sectores.length
							}
						})
						if (contador > 0)
							data.push({ anio: i, varCruzada: (sumador / contador).toFixed(2) })
						break
					default:
						errors.push("La opcion seleccionada como variable a cruzar no existe")
						flag = false;
						break;
				}
			}
		})

	}

	//Variable Principal Eficiencia
	else if (input.xAxis === 'Eficiencia') {
		var eficiencias = []

		projects.forEach(i => {
			if (i.Eficiencia && i.Eficiencia !== 'NO EXISTE' && !eficiencias.includes(i.Eficiencia))
				eficiencias.push(i.Eficiencia)
		})

		eficiencias.forEach(i => {
			var contador = 0;
			var sumador = 0;
			var contenedor = [];
			var catToNumber = 0;
			if (flag) {
				if (i === 'BAJA')
					catToNumber += 1
				if (i === 'MEDIA')
					catToNumber += 2
				if (i === 'MEDIA-ALTA')
					catToNumber += 3
				if (i === 'ALTA')
					catToNumber += 4
				if (i === 'MUY ALTA')
					catToNumber += 5

				switch (input.yAxis) {
					case 'Años':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Año) {
								contador++
								sumador += j.Año
							}
						})
						if (contador > 0)
							data.push({ anio: Math.round((sumador / contador).toFixed(2)), varCruzada: catToNumber })
						break
					case 'Actividades':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Actividades.length !== 0) {
								contador++;
								sumador += j.Actividades.length
							}
						})
						if (contador > 0)
							data.push({ anio: (sumador / contador).toFixed(2), varCruzada: catToNumber })
						break
					case 'Beneficiarios':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.NIndBenef) {
								contador++;
								sumador += j.NIndBenef
							}
						})
						if (contador > 0)
							data.push({ anio: (sumador / contador).toFixed(2), varCruzada: catToNumber })
						break
					case 'Entidades':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Entidades.length !== 0) {
								contador++;
								sumador += j.Entidades.length
							}
						})
						if (contador > 0)
							data.push({ anio: (sumador / contador).toFixed(2), varCruzada: catToNumber })
						break
					case 'Cofinanciadores':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Cofinanciadores.length !== 0) {
								contador++;
								sumador += j.Cofinanciadores.length
							}
						})
						if (contador > 0)
							data.push({ anio: (sumador / contador).toFixed(2), varCruzada: catToNumber })
						break
					case 'Lugares':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Lugares.length !== 0) {
								contador++;
								sumador += j.Lugares.length
							}
						})
						if (contador > 0)
							data.push({ anio: (sumador / contador).toFixed(2), varCruzada: catToNumber })
						break
					case 'Paises':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Pais && !contenedor.includes(j.Pais)) {
								contenedor.push(j.Pais)
								contador++
							}
						})
						if (contador > 0)
							data.push({ anio: contenedor.length, varCruzada: catToNumber })
						break
					case 'Sectores':
						projects.forEach(j => {
							if (j.Eficiencia === i && j.Sectores.length !== 0) {
								contador++;
								sumador += j.Sectores.length
							}
						})
						if (contador > 0)
							data.push({ anio: (sumador / contador).toFixed(2), varCruzada: catToNumber })
						break
					default:
						errors.push("La opcion seleccionada como variable a cruzar no existe")
						flag = false;
						break;
				}
			}
			if (data.length > 0) {
				data.forEach(i => {
					if (i.anio === 'BAJA')
						i.anio = 1
					if (i.anio === 'MEDIA')
						i.anio = 2
					if (i.anio === 'MEDIA-ALTA')
						i.anio = 3
					if (i.anio === 'ALTA')
						i.anio = 4
					if (i.anio === 'MUY ALTA')
						i.anio = 5
				})
				data.sort((a, b) => a.anio - b.anio);
			}
		})
	}

	if (errors.length > 0)
		return { errors }
	return { data };
}

const getTypes = async (args, req) => {
	if (!req.isAuth) {
		const error = new Error("Not authenticated!");
		error.code = 401;
		throw error;
	}

	const typesArray = await Type.find();
	const types = [];
	for (type of typesArray) {
		types.push(type.tipo_es)
	}

	if (types.length > 0) {
		return { types }
	}
	else
		return { errors: ["No se encuentran tipos registrados"] }

}

const insertProject = async (input, req) => {
	if (!req.isAuth) {
		const error = new Error("Not authenticated!");
		error.code = 401;
		throw error;
	}

	var values = input.input;
	var tipo, tipoRef;

	if (values.type) {
		tipo = values.type
		const newType = new Type({
			tipo_es: tipo
		})
		const createdType = await newType.save()
		tipoRef = createdType
	}
	if (values.typeSel) {
		tipo = values.typeSel
		tipoRef = await Type.findOne({ tipo_es: tipo })
	}


	const project = new Project({
		Acronimo: values.acronym,
		Beneficiario: values.beneficiary,
		Pais: values.country,
		Eficacia: values.effectiveness,
		Eficiencia: values.efficiency,
		RetrasoFinal: values.finalDelay,
		Identificador: values.identifier,
		Impacto: values.impact,
		RetrasoInicial: values.initialDelay,
		NAreBenef: values.nAreBenef,
		NFamBenef: values.nFamBenef,
		NIndBenef: values.nIndBenef,
		NPerSC: values.nPerSC,
		NPerSE: values.nPerSE,
		NPerSS: values.nPerSS,
		Participacion: values.participation,
		DuraciónReal: values.realTime,
		Pertinencia: values.relevance,
		Titulo: values.title,
		FinanciadoTotal: values.totalFinanced,
		CuantiaTotal: values.totalQuantity,
		Tipo: tipoRef._id,
		ValorTotalEjec: values.valorTotalEjec,
		ValorTotalPres: values.valorTotalPres,
		Viabilidad: values.viability,
		Visibilidad: values.visibility,
		Año: values.year,
	});

	const createdProject = await project.save()

	return true;
}
module.exports = {
	getGraph,
	getTypes,
	insertProject
}
