const { buildSchema } = require("graphql");
const User = require('./User');
const Graph = require('./Graph');

const GraphQlSchema =
	//Tipos
	User.types +
	Graph.types +
	//Inputs
	User.inputs +
	Graph.inputs +

	`
	type RootQuery {
		login(input: UserAuthData): AuthData!
		getGraph(input: GraphInputData): GraphData!
		getTypes: TypesData!
	}

	type RootMutation {
		insertProject(input: ProjectInputData): Boolean!
	}

	schema {
		query: RootQuery
		mutation: RootMutation
	}
	`;

module.exports = buildSchema(GraphQlSchema);